Subject: bug#41520: 28.0.50; Crash in character.h due to assertion error

From: Pip Cet <[email-masked]>
Date: Mon, 25 May 2020 07:28:23 +0000

On Mon, May 25, 2020 at 7:06 AM Stefan Kangas <[email-masked]> wrote:
> When editing an org-mode document, I saw a crash due to this assertion
> error:

It's a bug in this code in xdisp.c:

  else if (it->bidi_it.charpos == bob
       || (!string_p
           && (FETCH_CHAR (it->bidi_it.bytepos - 1) == '\n'
           || FETCH_CHAR (it->bidi_it.bytepos) == '\n')))

The first FETCH_CHAR should be a FETCH_BYTE to avoid the assertion error.

There's at least one other place that has the same error, so I'll grep
some more before sending a patch.

My suggestion is to drop the "eassume" on emacs-27, and fix FETCH_CHAR
to FETCH_BYTE on master.

(I'd like to reiterate my proposal to use a pos_t for bytepos/charpos
pairs, which would catch or silently fix (which happened in this case
on my pos_t branch) such bugs. The code on my branch reads:

  else if (POS_CHAR_EQUAL (it->bidi_it.pos, bob)
       || (!string_p
           && (FETCH_CHAR (dec_pos (it->bidi_it.pos)) == '\n'
           || FETCH_CHAR (it->bidi_it.pos) == '\n')))

which, while minimally slower, doesn't throw assertion errors.)